#!/usr/bin/perl -w
#
# $Id: SomeQueues.insert.pl,v 1.2 2002/12/19 15:53:43 bortzmeyer Exp $

package RT;

# Local settings
# Perl regular expression on the set of queues you want or does not want
my $set_of_queues = "!Info";
my $name_of_condition = "OnCreate_not_info";
my $transaction_types = "Create"; # You may put Any if you want to match other types 
                          # of transactions. You should then change the above name.
use lib "/local/rt2/lib";
use lib "/local/rt2/etc";

# NO USER-SERVICEABLE PARTS UNDER THIS LINE

use strict;
use vars qw($VERSION $Handle $Nobody $SystemUser $item);


#This drags in  RT's config.pm
use config;
use Carp;

use RT::Handle;
use RT::User;
use RT::CurrentUser;

#connect to the db
$RT::Handle = new RT::Handle($RT::DatabaseType);
$RT::Handle->Connect();


#Put together a current user object so we can create a User object
my $CurrentUser = new RT::CurrentUser();


#now that we bootstrapped that little bit, we can use the standard RT cli
# helpers  to do what we need

use RT::Interface::CLI  qw(CleanEnv LoadConfig DBConnect 
			   GetCurrentUser GetMessageContent);

#Clean out all the nasties from the environment
CleanEnv();

#Load etc/config.pm and drop privs
LoadConfig();

#Connect to the database and get RT::SystemUser and RT::Nobody loaded
DBConnect();


$CurrentUser->LoadByName('RT_System');

# {{{ ScripConditions

# The Argument is a list of queues.
my @ScripConditions = (
		       {
			Name => $name_of_condition,
			Description =>  'Indicates if the transaction is for a given set of Queues',
			ApplicableTransTypes =>  $transaction_types,
			Argument => $set_of_queues,  
			ExecModule => 'SomeQueues',
		       },
		       
		       
		      );

# }}}
print "Creating ScripConditions...";

use RT::ScripCondition;
for $item (@ScripConditions) {
    my $new_entry = new RT::ScripCondition($CurrentUser);
    my $return = $new_entry->Create(%$item);
    print $return.".";
}

print "done.\n";

$RT::Handle->Disconnect();


1;

