# $Id: SomeQueues.pm,v 1.1 2002/12/19 15:22:44 bortzmeyer Exp $

# Decide whether a Transaction was in a given set of Queues ot not

# Declare what we are:
package RT::Condition::SomeQueues;

$debug = 1;
$ident = "RT_Condition_SomeQueues";
$logopt = "pid";
$facility = 'user';

# Read in the Generic RT Goodness and load it
require RT::Condition::Generic;
@ISA = qw(RT::Condition::Generic);
use RT::Ticket;
use RT;

# For debugging
use Sys::Syslog;    

=head2 IsApplicable

If the Transaction is in a given set of Queues. The set is expressed
as a case-insensitive Perl regular expression.

=cut

sub IsApplicable {
    my $self = shift;

    my $retval = 0;
    my $applicable_msg = "REFUSED";
    my $transaction = $self->TransactionObj;
    my $queueset = $self->Argument;
    my $ticket = new RT::Ticket(RT::Nobody);
    $ticket->Load($transaction->Ticket);
    my $queue = $ticket->QueueObj->Name;
    my $negation = 0;
    if (substr($queueset, 0, 1) eq '!') {
	$negation = 1;
	$queueset = substr($queueset, 1);
    }
    if (! $negation) {
	if ($queue =~ /^$queueset$/i) {
	    $retval = 1;
	}
    }
    else {
	if ($queue !~ /^$queueset$/i) {
	    $retval = 1;
	}
    }
    if ($retval) {
	$applicable_msg = "ACCEPTED";
    }
    if ($debug) {
	openlog ($ident, $logopt, $facility);
	syslog ('debug', 
		"Transaction in queue %s (the accepted set is %s%s) " . 
		"is for ticket %d: %s",
		$queue, $queueset, $negation?" - NEGATED":"", 
		$transaction->Ticket, $applicable_msg);
	closelog;
    }
   return($retval);
}

1;

